# tn-tile-worker

เป็นโปรแกรมสำหรับ Render PBF Vector และ Raster Tile ทำงานร่วมกับ RabbitMQ

## Requires
 - Ubuntu 16.04.2 LTS
 - MapNik 3.x
 - NodeJS 4.x
 - node-gyp
 - tnvectortile-native

## Installing
node 4.8.0
```
curl -sL https://deb.nodesource.com/setup_4.x | sudo -E bash -  
sudo apt-get install nodejs
node -v  //ตรวจสอบ node version ว่าเป็น version 4.8.0
```

gyp-node 
```
sudo apt install node-gyp
```

python 2.7
```
sudo apt-get install python2.7
npm config set python /usr/bin/python2.7
```

MapNik  3.x
```
apt-get install libmapnik-dev libmapnik3.0 mapnik-utils mapnik-vector-tile python-mapnik python3-mapnik
```
tnvectortile-native
```
cp libtnvectortile.so /usr/lib/libtnvectortile.so
```

## Run 

```
git clone git@gitlab.thinknet.co.th:mapmagicgl/tnvectortile.git
cd tnvectortile
cp libtnvectortile.so /usr/lib/libtnvectortile.so
npm install
npm start
```

## เพิ่ม Style
```
- Copy MapGL Style ไปใช้ที่ folder style
- เพิ่ม style ใน config.json
```
config.json
```
{
    "aws": {
        "awsAccessKeyId": AWS AccessKey
        "awsSecretAccessKey": AWS Secret Access Key ,
        "awsRegion": AWS Region,
        "awsBucketNameFormat": "vtiles-mmg-2017-{name}" <-- AWS Bucket Format
    },
    "styles": [
        {
            "name": "normal", <-- name style
            "style": "./style/mapmagic_normal.xml", <-- file MapNik Style XML
            "port": 10101 <-- port service
        },
        ....
    ]
}
```
## URL Format
```
 http://{domain name}:{port}/v2/{style name}/{z}/{x}/{y}.pbf

Example
 http://52.77.4.36:10101/v2/normal/16/51073/30246.pbf
```

## เปลี่ยน Polygon สำหรับ Merge ข้อมูล OSM
```
 Replace ไฟล์ thailand_polygon.geojson
```