const cluster = require('cluster');
if(cluster.isMaster) {
    const numWorkers = 6; //require('os').cpus().length;
    console.log('Master cluster setting up ' + numWorkers + ' workers...');
    for(var i = 0; i < numWorkers; i++) {
        cluster.fork();
    }
    cluster.on('exit', (worker, code, signal) => {
        console.log('worker %d died (%s). ', worker.process.pid, signal || code);
        //cluster.fork();
    });
} else {
    const tilelive = require('tilelive');
    const amqp = require('amqplib');
    const createChannelRenderTile = require('./tnvtchannel');
    
    const mbtilesFile = '/home/ubuntu/mbtiles/planet_2016_06_20_z0-14.mbtiles';
    require('mbtiles').registerProtocols(tilelive);

    tilelive.load('mbtiles://' + mbtilesFile, function(err, source) {
        amqp.connect('amqp://localhost').then(function(conn) {
            process.once('SIGINT', function() { conn.close(); });
            return createChannelRenderTile(conn, source);
        }).catch(console.warn);
    });
}