const s3 = require('s3');
const aws = require('aws-sdk');
const moment = require('moment');
const maxTimeForRender = 15; //secounds
module.exports = {
    checkIsRendering: function(awsClient, bucketName, key, callback){
        var awsParams = { Bucket: bucketName,
                          Key: key
                        };
        awsClient.getObject(awsParams, function(err, awsdata) {
             if(err){
                 callback(null, false);
             }else{
                //console.log(awsdata['Body'].toString());
                var renderTime = moment(awsdata['Body'].toString(), "YYYY-MM-DD'T'HH:mm:ss:SSSZ");
                var now = moment();
                var secondsDiff = now.diff(renderTime, 'seconds')
                //console.log(secondsDiff);
                if(secondsDiff<maxTimeForRender){
                  callback(null, true);
                }else{
                  console.log('time out render (%s)', key);
                  awsClient.deleteObject(awsParams, function(err, awsdata) {
                     callback(null, false);
                  });
                }
             }
        });
    },
    addTileRendering: function(awsClient, bucketName, key, callback){
        var datetime = new Date();
        var awsParams = { Bucket: bucketName,
                          Key: key,
                          ContentType: 'text/plain',
                          Body: datetime.toISOString(),
                          ACL: 'private'
                        };
        awsClient.putObject(awsParams, function(err, data){
            if (err) {
                console.log(err, err.stack);
                callback(err, false);
            }else {
                callback(null, true);
            }
        });
        
    },
    deleteTileRendering: function(awsClient, bucketName, key, callback){
        var awsParams = { Bucket: bucketName,
                          Key: key
                        };
        awsClient.deleteObject(awsParams, function(err, awsdata) {
             if(err){
                 callback(null, false);
             }else{
                callback(null, true);
             }
        });
    }
};